/*	AWP Retribution v1.2  by Joe  (joeatrr@yahoo.com)

	This plugin will detect when someone buys an AWP.  It will take away health,
	kill, kick, then ban (15 minutes) according to the number of awp's they've bought.
	(Will optionally ban permanently after a 15 minute ban and another violation.)
	
	** Take a look at and edit the four settings below the #define lines below.
	   And there are compile instructions after those settings as well.
	
	***New Commands:
		admin_awpcheck #:  #=1 or 0 (on or off).  If no # given, shows current status.
		admin_awpstat:  Shows current stats (Total # of slaps, slays, kicks, bans)
							 Since server started...
*/

#include <core>
#include <console>
#include <string>
#include <admin>
#include <adminlib>

#define ITEM_INVALID -1
#define MAX_MENU_CHOICES 10
#define MAX_MENUS 10
#define MENU_EQUIPMENT 8
#define MENU_INVALID -1
#define MENU_TOP 0
#define AWP_SLAP 16
#define AWP_SLAY 32
#define AWP_KICK 64
#define AWP_BAN 128
#define ACCESS_LOGD 131072

///////////////////////////////////////////////////////////////////////////////////////
///                           EDIT THESE FOUR SETTINGS!!!                           ///
///////////////////////////////////////////////////////////////////////////////////////


////////   THESE NEXT TWO LINES ARE USED WHEN SOMEONE IS PERMANENTLY BANNED.
////////   IT GIVES THEM AN OPTION TO EMAIL THE ADMIN FOR FORGIVENESS.

/// Edit the name and email address, making sure to keep the "" where htey are.

/* NOTE that leaving tAdminsEmail="" will disable the notification
   that offenders received upon being banned.  This means they do 
   not know whom they should contact, and thus may never be able
   to join your server again!  Add the e-mail address to be safe =) */
new tAdminsName[MAX_NAME_LENGTH]  = "NONE CONFIGURED" ;  // <-- PUT YOUR NAME HERE!!!
new tAdminsEmail[MAX_DATA_LENGTH] = ""    ;  // <-- PUT YOUR EMAIL HERE!!


new iPermBanAfterTempBan=1;	// Set this to 0 if you want it to always ONLY ban people
				// For 15 minutes at a time.  Setting this to 1 will ban a
				// Person permanently if he comes back and awps after being
				// banned once for 15 minutes.

new AwpCheck=1;			// Default awp-checking status (on startup)




/* OK, now you're done with customizing the script.  If you know what you're doing, feel
   free to tinker with it ;).  Otherwise, just save this (into your Admin/scripting/myscripts
   Directory and run 'compile_all.bat' (or compile_all.sh in linux) in the same directory.  
   Then move plugin_joe_awp.amx from Admin/scripting/mybinaries into Half-Life/cstrike/dlls and 
   then edit the Half-Life/cstrike/plugin.ini file, adding the line:
      dlls/plugin_joe_awp.amx
   To the file;  Save it, then restart the server.  You're done.
*/


///////////////////////////////////////////////////////////////////////////////////////
///                YOU SHOULD NOT NEED TO EDIT BEYOND THIS...                       ///
///////////////////////////////////////////////////////////////////////////////////////

// Totals for slaps, slays, kicks, bans
new AwpSlap=0;
new AwpSlay=0;
new AwpKick=0;
new AwpBan=0;
new AwpWarns[MAX_PLAYERS];
new tKick[MAX_NAME_LENGTH]="";
new tSlay[MAX_NAME_LENGTH]="";
new tNote[MAX_NAME_LENGTH]="";
new STRING_VERSION[MAX_DATA_LENGTH]="1.5b";
new UserMenu[MAX_PLAYERS];
new UserFlags[MAX_PLAYERS];

public plugin_init() {
	
	plugin_registerinfo("Joe's AWP buying detection","Auto detects, warns, slaps, and kicks AWP-buyers when enabled.",STRING_VERSION);
	plugin_registercmd("admin_AwpCheck","admin_AwpCheck",ACCESS_KICK,"admin_AwpCheck 1/0:  Turns AWP-checking on or off.");
	plugin_registercmd("admin_awpstat","awpstat",ACCESS_KICK,"admin_awpstat:  Displayes current status of all users and their AWP buys and warnings.");
	plugin_registercmd("buy","SetMenuData",ACCESS_ALL);
	plugin_registercmd("admin_drops", "admin_drops", ACCESS_IMMUNITY, "admin_drops <user> <slot to drop> Drop the user's weapon in a given slot.");
	plugin_registercmd("showbriefing","BriefThis",ACCESS_ALL);
	plugin_registercmd("menuselect","SetSelectData",ACCESS_ALL);
	plugin_registercmd("logd_kill", "awp_kill", ACCESS_LOGD, "");
		
	return PLUGIN_CONTINUE;
}

public drops(target[],slot) {  // This will drop the weapon in <target>'s <slot> slot.
	new TargetName[MAX_NAME_LENGTH];
	get_username(target,TargetName,MAX_NAME_LENGTH);
	new msg[MAX_TEXT_LENGTH];
	snprintf(msg,MAX_TEXT_LENGTH,"slot%i",slot);
	execclient(target, msg);
	execclient(target,"+attack");
	execclient(target,"-attack");
	execclient(target,"drop");
	msg="ADMIN dropped ";
	strcat(msg, TargetName, MAX_DATA_LENGTH);
	strcat(msg, "'s weapon.", MAX_DATA_LENGTH);
	say(msg);
}

public admin_drops(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_DATA_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new iSlot;
	new strT2[MAX_DATA_LENGTH];
	new strT1[MAX_DATA_LENGTH];
	new User[MAX_DATA_LENGTH];
	new TargetName[MAX_NAME_LENGTH];
	new target[MAX_NAME_LENGTH];
	new strSlot[MAX_DATA_LENGTH];
	new Text[MAX_DATA_LENGTH];
	
	convert_string(HLCommand,Command,MAX_DATA_LENGTH);
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_DATA_LENGTH);
	strbreak(Data,strT1,strT2, MAX_DATA_LENGTH); 
	
	strbreak(Data,target,strSlot, MAX_DATA_LENGTH); 
	iSlot = strtonum(strSlot);
	get_username(target,TargetName,MAX_NAME_LENGTH);
	if (check_user(TargetName)==1) { 
		if(check_immunity(TargetName)!=0) { 
			strcat(Text, "LoL...  You can't drop ", MAX_TEXT_LENGTH);
			strcat(Text,TargetName,MAX_DATA_LENGTH);
			strcat(Text, "'s weapon.",MAX_DATA_LENGTH); 
			say(Text);
			return PLUGIN_HANDLED;
		} else {
			if(iSlot>9 || iSlot <1) {
				selfmessage("Invalid slot to drop.");
			} else {
				drops(target,iSlot);
				
			}
		}
	} else { 
		selfmessage( "Unrecognized player: "); 
		selfmessage( TargetName ); 
	} 
	return PLUGIN_HANDLED;
} 

AddUserFlag(UserIndex, Flag) {
	new Name[MAX_NAME_LENGTH];
	new strWONID[MAX_NUMBER_LENGTH];
	new UserID;
	new VaultData[MAX_DATA_LENGTH];
	new WONID;
	UserFlags[UserIndex] = UserFlags[UserIndex] | Flag;
	if (Flag == AWP_SLAP && getvar("sv_lan") == 0) {
		if (playerinfo(UserIndex,Name,MAX_NAME_LENGTH,UserID,WONID) != 0) {
			numtostr(WONID,strWONID);
			if(get_vaultdata(strWONID,VaultData,MAX_DATA_LENGTH) != 0) {
				if (strcasestr(VaultData," awpslap") == -1) {
					strcat(VaultData," awpslap", MAX_DATA_LENGTH);
					set_vaultdata(strWONID,VaultData);
				}
			} else {
				strcpy(VaultData, " awpkick", MAX_DATA_LENGTH); 			
				set_vaultdata(strWONID,VaultData);
			}
		}
	}
	if (Flag == AWP_SLAY && getvar("sv_lan") == 0) {
		if (playerinfo(UserIndex,Name,MAX_NAME_LENGTH,UserID,WONID) != 0) {
			numtostr(WONID,strWONID);
			if(get_vaultdata(strWONID,VaultData,MAX_DATA_LENGTH) != 0) {
				if (strcasestr(VaultData," awpslay") == -1) {
					strcat(VaultData," awpslay", MAX_DATA_LENGTH);
					set_vaultdata(strWONID,VaultData);
				}
			} else {
				strcpy(VaultData, " awpslay", MAX_DATA_LENGTH); 			
				set_vaultdata(strWONID,VaultData);
			}
		}
	}
	if (Flag == AWP_KICK && getvar("sv_lan") == 0) {
		if (playerinfo(UserIndex,Name,MAX_NAME_LENGTH,UserID,WONID) != 0) {
			numtostr(WONID,strWONID);
			if(get_vaultdata(strWONID,VaultData,MAX_DATA_LENGTH) != 0) {
				if (strcasestr(VaultData," awpkick") == -1) {
					strcat(VaultData," awpkick", MAX_DATA_LENGTH);
					set_vaultdata(strWONID,VaultData);
				}
			} else {
				strcpy(VaultData, " awpkick", MAX_DATA_LENGTH); 			
				set_vaultdata(strWONID,VaultData);
			}
		}
	}
	if (Flag == AWP_BAN && getvar("sv_lan") == 0) {
		if (playerinfo(UserIndex,Name,MAX_NAME_LENGTH,UserID,WONID) != 0) {
			numtostr(WONID,strWONID);
			if(get_vaultdata(strWONID,VaultData,MAX_DATA_LENGTH) != 0) {
				if (strcasestr(VaultData," awpban") == -1) {
					strcat(VaultData," awpban", MAX_DATA_LENGTH);
					set_vaultdata(strWONID,VaultData);
				}
			} else {
				strcpy(VaultData, " awpban", MAX_DATA_LENGTH);				
				set_vaultdata(strWONID,VaultData);
			}
		}
	}
}

CheckVaultFlags(UserIndex) {
	new Name[MAX_NAME_LENGTH];
	new strWONID[MAX_NUMBER_LENGTH];
	new UserID;
	new VaultData[MAX_DATA_LENGTH];
	new WONID;
	
	if (getvar("sv_lan") == 0) {
		if (playerinfo(UserIndex,Name,MAX_NAME_LENGTH,UserID,WONID) != 0) {
			numtostr(WONID,strWONID);
			if(get_vaultdata(strWONID,VaultData,MAX_DATA_LENGTH) != 0) {
				if (strcasestr(VaultData," awpslap") != -1) {
					UserFlags[UserIndex] = UserFlags[UserIndex] | AWP_SLAP;
				}
				if (strcasestr(VaultData," awpslay") != -1) {
					UserFlags[UserIndex] = UserFlags[UserIndex] | AWP_SLAY;
				}
				if (strcasestr(VaultData," awpkick") != -1) {
					UserFlags[UserIndex] = UserFlags[UserIndex] | AWP_KICK;
				}
				if (strcasestr(VaultData," awpban") != -1) {
					UserFlags[UserIndex] = UserFlags[UserIndex] | AWP_BAN;
				}
			}
		}
	}	
}

RemoveUserFlag(UserIndex, Flag) {
	new Name[MAX_NAME_LENGTH];
	new strWONID[MAX_NUMBER_LENGTH];
	new UserID;
	new VaultData[MAX_DATA_LENGTH];
	new WONID;
	
	UserFlags[UserIndex] = UserFlags[UserIndex] & ~Flag;
	if (Flag == AWP_SLAP && getvar("sv_lan") == 0) {
		if (playerinfo(UserIndex,Name,MAX_NAME_LENGTH,UserID,WONID) != 0) {
			numtostr(WONID,strWONID);
			if(get_vaultdata(strWONID,VaultData,MAX_DATA_LENGTH) != 0) {
				if (strcasestr(VaultData," awpslap") != -1) {
					strsubst(VaultData," awpslap", "", MAX_DATA_LENGTH);
					set_vaultdata(strWONID,VaultData);
				}
			}
		}
	}
	if (Flag == AWP_SLAY && getvar("sv_lan") == 0) {
		if (playerinfo(UserIndex,Name,MAX_NAME_LENGTH,UserID,WONID) != 0) {
			numtostr(WONID,strWONID);
			if(get_vaultdata(strWONID,VaultData,MAX_DATA_LENGTH) != 0) {
				if (strcasestr(VaultData," awpslay") != -1) {
					strsubst(VaultData," awpslay", "", MAX_DATA_LENGTH);
					set_vaultdata(strWONID,VaultData);
				}
			}
		}
	}
	if (Flag == AWP_KICK && getvar("sv_lan") == 0) {
		if (playerinfo(UserIndex,Name,MAX_NAME_LENGTH,UserID,WONID) != 0) {
			numtostr(WONID,strWONID);
			if(get_vaultdata(strWONID,VaultData,MAX_DATA_LENGTH) != 0) {
				if (strcasestr(VaultData," awpkick") != -1) {
					strsubst(VaultData," awpkick", "", MAX_DATA_LENGTH);
					set_vaultdata(strWONID,VaultData);
				}
			}
		}
	}
	if (Flag == AWP_BAN&& getvar("sv_lan") == 0) {
		if (playerinfo(UserIndex,Name,MAX_NAME_LENGTH,UserID,WONID) != 0) {
			numtostr(WONID,strWONID);
			if(get_vaultdata(strWONID,VaultData,MAX_DATA_LENGTH) != 0) {
				if (strcasestr(VaultData," awpban") != -1) {
					strsubst(VaultData," awpban", "", MAX_DATA_LENGTH);
					set_vaultdata(strWONID,VaultData);
				}
			}
		}
	}
}

PlayThunderClap() {
	new i;
	new iMaxPlayers = maxplayercount();
	new Name[MAX_NAME_LENGTH];
	new UserID;
	new WONID;
	
	if (getvar("admin_fx") != 0) {	
		for (i = 1; i <= iMaxPlayers; i++) {
			if (playerinfo(i,Name,MAX_NAME_LENGTH,UserID,WONID) != 0) {
				playsound(Name, "ambience/thunder_clap.wav");
			}
		}
	}
}

public doSlay() {
	teleport(tSlay,5000,5000,5000);	
	execclient(tSlay,"kill");
	strinit(tSlay);
	return PLUGIN_CONTINUE;
}

public doKick() {
	teleport(tKick,5000,5000, 5000);	
	execclient(tKick,"disconnect");
	//kick(tKick);
	strinit(tKick);
	return PLUGIN_CONTINUE;
}

public telladmin(Text[])
{
	new Name[MAX_NAME_LENGTH];
	new SessionID;
	new Team;
	new WONID;
	new maxplayers=maxplayercount();
	new i;
	new tLog[MAX_TEXT_LENGTH]="To Admins: ";
	for(i=1; i<=maxplayers; i++) {
		strinit(Name);
		if(playerinfo(i,Name,MAX_NAME_LENGTH,SessionID,WONID,Team)==1) {
			if(access(ACCESS_BAN,Name)!=0) {
				messageex(Name, Text, print_chat);
			}
		}
	}
	strcat(tLog,Text,MAX_TEXT_LENGTH);
	log(tLog);
	return PLUGIN_HANDLED;
}

public admin_AwpCheck(HLCommand,HLData,HLUserName,UserIndex) {

/* Use this to turn checking on/off */

	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	
	convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	if (strlen(Data)==0) {
		snprintf(Text,MAX_TEXT_LENGTH,"AWP-checking: %i",AwpCheck);
		selfmessage(Text);
	}
	else if(check_param(Data)==1) {
		selfmessage("AWP checking has been turned on!");
		AwpCheck=1;
		say_command(User,Command,Data);
	} 
	else {
		selfmessage("AWP checking has been disabled!");
		AwpCheck=0;
		say_command(User,Command,Data);
	}
	return PLUGIN_HANDLED;
}

public HandleAwp(sUser[], iWarns) {
	new Text[MAX_TEXT_LENGTH]="";
	new tText[MAX_TEXT_LENGTH]="";
	strcat(Text,sUser,MAX_NAME_LENGTH);
	new iUser;
	get_userindex(sUser,iUser);
	if(iWarns==1) {
		for(new i=0;i<19;i++) {
			slap(sUser);
		}
		execclient(sUser,"say OUCH!  That hurt!!!");
/*What he says when he buys first */
		AwpSlap++;
		/* v--  What Admin's see when first buy occurs: */
		strcat(Text," has bought his first AWP and slapped to 5hp for it.",MAX_TEXT_LENGTH);
		telladmin(Text);
	} 
	else if(iWarns==2) {
		execclient(sUser,"say Oh my GOD!!");
// Said on second buy.
		execclient(sUser,"say /me screams horrifically..."); // Only works with the IRC-action plugin
		strinit(tText);
		strcat(tText,sUser,MAX_NAME_LENGTH);
		strcat(tText," has learned the true meaning of the term AWP-whore..., after being ass-raped by one.",MAX_TEXT_LENGTH);  // Be creative...  =P
		say(tText);
		strinit(tSlay);
		strcat(tSlay,sUser,MAX_NAME_LENGTH);
		set_timer("doSlay",2,1);
		AwpSlay++;
		messageex(sUser,"That was your second AWP!^nNext time you will be kicked!!",print_center);
		strcat(Text," has bought his 2nd AWP and killed for it.",MAX_TEXT_LENGTH);
		telladmin(Text);
	} 
	else if(iWarns==3) {
		PlayThunderClap();
		RemoveUserFlag(iUser,AWP_SLAY);
		AddUserFlag(iUser,AWP_KICK); // Add flag so we know next time he connects that he's been kicked
		execclient(sUser,"say I'm a dirty AWP whore...");
		messageex(sUser,"You have bought 3 AWPs...  You were warned last time^nRead the MOTD if you come back^nGood-Bye",print_center);
		messageex(sUser,"You have bought 3 AWPs...  You were warned last time^nRead the MOTD if you come back^nGood-Bye",print_console);
		strinit(tKick);
		strcat(tKick,sUser,MAX_NAME_LENGTH);
		set_timer("doKick",2,1);
		AwpKick++;
		strcat(Text," has bought his last AWP...  Bye-bye...",MAX_TEXT_LENGTH);
		telladmin(Text);
		AddUserFlag(iUser,AWP_KICK);
		strinit(Text);
		strcat(Text,sUser,MAX_NAME_LENGTH);
		strcat(Text," has been kicked for buying 3 AWPs!",MAX_TEXT_LENGTH);
		centersay(Text,10,255,0,0);
	} else if(iPermBanAfterTempBan==1 && iWarns==4) {
		PlayThunderClap();
		RemoveUserFlag(iUser,AWP_KICK);
		AddUserFlag(iUser,AWP_BAN); // Change KICK vault flag to BAN flag
		messageex(sUser,"You were kicked before for AWPing.  You have now been banned for 15 minutes!",print_center);
		messageex(sUser,"You were kicked before for AWPing.  You have now been banned for 15 minutes!",print_console);
		snprintf(Text,MAX_TEXT_LENGTH,"%s was banned for 15 minutes for awping!",sUser);
		say(Text);
		log(Text);
		ban(sUser,15);
		AwpBan++;
	} else if(iPermBanAfterTempBan==1 && iWarns>4) {
		PlayThunderClap();
		RemoveUserFlag(iUser,AWP_KICK);
		AddUserFlag(iUser,AWP_BAN); // Change KICK vault flag to BAN flag
		messageex(sUser,"You have been banned before for AWPing.  Now, don't come back...",print_center);
		messageex(sUser,"You have been banned before for AWPing.  Now, don't come back...",print_console);
		if(strlen(tAdminsEmail)>0){
			snprintf(Text,MAX_TEXT_LENGTH,"^nE-mail %s at %s to contest this ban.",tAdminsName,tAdminsEmail);
			messageex(sUser,Text,print_console);
		} else {
			snprintf(Text,MAX_TEXT_LENGTH,"The admin (^"%s^") has not specified an email address for contestation.",tAdminsName);
			messageex(sUser,Text,print_console);
			messageex(sUser,"That means you must find some other way to contact the admin to lift this ban.",print_console);
		}
		snprintf(Text,MAX_TEXT_LENGTH,"%s was banned permanently for awping!",sUser);
		say(Text);
		log(Text);
		ban(sUser,0);
		AwpBan++;
	} else if(iPermBanAfterTempBan==0 && iWarns>=4) {
		PlayThunderClap();
		RemoveUserFlag(iUser,AWP_KICK);
		AddUserFlag(iUser,AWP_BAN); // Change KICK vault flag to BAN flag
		messageex(sUser,"You were kicked before for AWPing.  You have now been banned for 15 minutes!",print_center);
		messageex(sUser,"You were kicked before for AWPing.  You have now been banned for 15 minutes!",print_console);
		snprintf(Text,MAX_TEXT_LENGTH,"%s was banned for awping!",sUser);
		log(Text);
		telladmin(Text);
		ban(sUser,30);
		AwpBan++;
	} else {
		log("Joe's AWP had a weird experience...  iWarns Out of Range...");
 	}
	return PLUGIN_CONTINUE;
}

public BriefThis(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new i;
	convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	for(i=0;i<3;i++)
		slap( User );
	messageex(User,"This server does not allow the command ^"showbriefing^"",print_console);
	messageex(User,"to be used.  If you are using it with the intent of cheating,",print_console);
	messageex(User,"Leave now.",print_console);
	messageex(User," ",print_console);
	messageex(User,"Brief THIS",print_tty);
	snprintf(Text,MAX_TEXT_LENGTH,"%s has tried to use the 'showbriefing' command!",User);
	telladmin(Text);
	return PLUGIN_HANDLED;
}

public awpstat(HLCommand,HLData,HLUserName,UserIndex) {
	// Shows status of all users in game and # of awp buys for each.
	// Also shows total number of each step of buy since server start
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	new Name[MAX_NAME_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new i;
	new tempstr[MAX_TEXT_LENGTH]="";
	new swon[MAX_TEXT_LENGTH]="";
	new ssess[MAX_TEXT_LENGTH]="";
	new iind=0;
	new SessionID;
	new Team;
	new WONID;
	new maxplayers=maxplayercount();
	convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	selfmessage("[ADMIN] Joe's AWP-Checking Retaliation!  =)");
	// This works beautifully from server console because of non-scalable fonts...  
	// game console it looks funny.  =P
	for(i=1;i<maxplayers;i++) {
		strinit(Name);
		if(playerinfo(i,Name,MAX_NAME_LENGTH,SessionID,WONID,Team)==1) {
			snprintf(tempstr,MAX_TEXT_LENGTH,"%i. %s",i, Name);
			strcat(tempstr,"                             ",30);
			snprintf(ssess,MAX_TEXT_LENGTH,"L: %i",SessionID);
			strcat(ssess,"                   ",6);
			snprintf(swon,MAX_TEXT_LENGTH,"W: %i",WONID);
			strcat(swon,"                   ",11);
			snprintf(Text,MAX_TEXT_LENGTH,"%s %s %s Awps: %i",tempstr,ssess,swon,AwpWarns[i]);
			if(get_userindex(User,iind)==1)
				if(iind!=0)
					messageex(User,Text,print_console);
			log(Text);
		}
		
	}
	snprintf(Text,MAX_TEXT_LENGTH,"AwpSlaps: %i; AwpSlays: %i; AwpKicks: %i; AwpBans: %i",AwpSlap,AwpSlay,AwpKick,AwpBan);
	if(get_userindex(User,iind)==1)
		if(iind!=0) {
			messageex(User,"=====TOTALS=====",print_console);
			messageex(User,Text,print_console);
		}
	log("=====TOTALS=====");
	log(Text);
	return PLUGIN_HANDLED;
}


/*********************************************************************************************
 * I can't lie...  These are modified versions of the functions from the plugin_CS file for  *
 * weapons restrictions...  I took out the stuff I didn't need, and added a function call    *
 * if(AwpCheck is 1) -- set by default at top or by admin_awpcheck 0/1 command               *
 *********************************************************************************************/
public SetMenuData(HLCommand,HLData,HLUserName,UserIndex) {
	
	new Command[MAX_COMMAND_LENGTH];
	convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
	if (streq(Command, "buyequip")==1) {
		UserMenu[UserIndex] = MENU_EQUIPMENT;
	} 
	else if (streq(Command, "buy")==1) {
		UserMenu[UserIndex] = MENU_TOP;
	} 
	else if (streq(Command, "showbriefing")==1) {
		if (UserMenu[UserIndex] == MENU_INVALID) {
			UserMenu[UserIndex] = 1;
		}
	}
	return PLUGIN_CONTINUE;
}

public SetSelectData(HLCommand,HLData,HLUserName,UserIndex) {
	new Data[MAX_DATA_LENGTH];
	new Text[MAX_DATA_LENGTH]="";
	new User[MAX_NAME_LENGTH];
	new iMenu;
	new iUser;
	new iUserInd;
	new Name[MAX_NAME_LENGTH];
	new SessionID;
	new Team;
	new WONID;
	new maxplayers=maxplayercount();
	new i;
	
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	iMenu = UserMenu[UserIndex];
	if (iMenu == MENU_TOP) {
		new iNewMenu = strtonum(Data);
		if (iNewMenu == 6 || iNewMenu == 7 || iNewMenu == 10) {
			UserMenu[UserIndex] = MENU_INVALID;
		} 
		else {
			UserMenu[UserIndex] = iNewMenu;
		}
	} 
	else if (iMenu > MENU_INVALID) {
		new iNewItem = strtonum(Data);
		if(iMenu==4 && iNewItem==6) {
			for(i=1; i<=maxplayers; i++) {
				strinit(Name);
				if(playerinfo(i,Name,MAX_NAME_LENGTH,SessionID,WONID,Team)==1) {
					if(streq(Name,User)) {
						iUser=WONID;
						iUserInd=i;
					}
				}
			}
			snprintf(Text, MAX_TEXT_LENGTH, "NOTE: <%i>%s is buying an AWP/AWM!!  Get ready to kick...  =P", iUser,User);
			if(AwpCheck==1)
			{
				AwpWarns[iUserInd]+=1;
				HandleAwp(User, AwpWarns[iUserInd]);
			}
			else {
				telladmin(Text);
			}
		}
		if (iNewItem==10) {
			UserMenu[UserIndex] = MENU_INVALID;
		} 
		else {
			UserMenu[UserIndex] = MENU_INVALID;
		}
	} 
	else if (iMenu >= MENU_INVALID) {
		UserMenu[UserIndex] = MENU_INVALID;
	}
	return PLUGIN_CONTINUE;
}

public awp_kill(HLCommand,HLData,HLUserName,UserIndex)
{
	new sID1[MAX_NUMBER_LENGTH];
	new sID2[MAX_NUMBER_LENGTH];
	new NameA[MAX_NAME_LENGTH];
	new NameV[MAX_NAME_LENGTH];
	new Params[MAX_DATA_LENGTH];
	new Log[MAX_DATA_LENGTH];
	new Weapon[MAX_NAME_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new iID1 = strtonum(sID1);
	new iID2 = strtonum(sID2);
	new dmy;
	new WONID;
	new sWONID[MAX_TEXT_LENGTH];
	convert_string(HLData,Params,MAX_DATA_LENGTH);
	convert_string(HLData, Data, MAX_DATA_LENGTH);
	strsplit(Data, " ", sID1, MAX_NUMBER_LENGTH, sID2, MAX_NUMBER_LENGTH, Weapon, MAX_NAME_LENGTH);
	if( !playerinfo(iID1,NameA,MAX_NAME_LENGTH,dmy,WONID) ) {
		return PLUGIN_FAILURE;
	}
	if( !playerinfo(iID2,NameV,MAX_NAME_LENGTH) ) {
		return PLUGIN_FAILURE;
	}
	numtostr(WONID,sWONID);
	if( strcmp( Weapon, "weapon_awp") == 0 && AwpCheck==1)
	{
		RemoveUserFlag(iID1,AWP_SLAY);
		AddUserFlag(iID1,AWP_KICK); /*Treat as an AWP-Kick, so next time, jump right to ban! */
		snprintf(Log,MAX_DATA_LENGTH,"%s has broken the rules by using an AWP!!",NameA);
		log(Log);
		messageex(NameA,"You have used a banned weapon.  You dipshit!",print_console);
		ban(NameA,1);
		/*ban(sWONID, 24 * 60);*/
		telladmin("AWP-killer was kicked!");
	}
	return PLUGIN_CONTINUE;
}

public notifyofawp() { 
// Couldn't figure out how to use variables for things like a timeout, so did it the complicated way =(
	messageex(tNote,"You have been kicked before for AWPing!^nYou WILL be BANNED if you buy another AWP!!",print_console);
	messageex(tNote,"You have been kicked before for AWPing!^nYou WILL be BANNED if you buy another AWP!!",print_tty);
	strinit(tNote);
}

public plugin_connect(HLUserName, HLIP, UserIndex) {
	new name[MAX_NAME_LENGTH];
	new tText[MAX_TEXT_LENGTH];
	strinit(tText);
	convert_string(HLUserName,name,MAX_NAME_LENGTH);
	consgreet("WARNING, THIS SERVER MONITORS AWP-BUYS VIA JOE'S AWP-RETAL ADMINMOD PLUGIN!");
	consgreet("DO NOT BUY AN AWP!");
	if(AwpCheck==1) { consgreet("AWP-Checking is currently ENABLED!"); }
	consgreet("Joe:  joeatrr@yahoo.com");
	consgreet("");
	if (UserIndex >= 1 && UserIndex <= MAX_PLAYERS) {
		UserMenu[UserIndex] = MENU_INVALID;
		CheckVaultFlags(UserIndex);
		if ((UserFlags[UserIndex] & AWP_SLAP) == AWP_SLAP) {
			AwpWarns[UserIndex]=1;
		} else if ((UserFlags[UserIndex] & AWP_SLAY) == AWP_SLAY) {
			AwpWarns[UserIndex]=2;
		} else if ((UserFlags[UserIndex] & AWP_KICK) == AWP_KICK) {
			AwpWarns[UserIndex]=3;
			strcat(tText,"WARNING: ",MAX_NAME_LENGTH);
			strcat(tText,name,MAX_TEXT_LENGTH);
			
			// This tells everyone that this guy's been kicked before for buying 3 awps
			strcat(tText," AWPs and has been^nkicked for it once!",MAX_TEXT_LENGTH);
			centersay(tText,10,255,0,0);
			strinit(tNote);
			strcat(tNote,name,MAX_NAME_LENGTH);
			set_timer("notifyofawp",25,1);
		} else if ((UserFlags[UserIndex] & AWP_BAN) == AWP_BAN) {
			strcat(tText,name,MAX_NAME_LENGTH);
			
			// This tells them that this guy has bought 4+ awps...
			strcat(tText," has been known to AWP and^nhas been BANNED for it before!!",MAX_TEXT_LENGTH);
			AwpWarns[UserIndex]=4;
			centersay(tText,10,255,0,0);
			set_timer("notifyofawp",25,1); // Tells AWPer that he'll be banned next time
		} else {
			AwpWarns[UserIndex] = 0;
		}
	}
	return PLUGIN_CONTINUE;
}

public plugin_disconnect(HLUserName, UserIndex) {
	if (UserIndex >= 1 && UserIndex <= MAX_PLAYERS) {
		UserMenu[UserIndex] = MENU_INVALID;
		AwpWarns[UserIndex] = 0;
	}
	return PLUGIN_CONTINUE;
}